;;;Programm zum Erstellen von Blattrahmen mit Faltmarkierungen
;;;Britt Grapentin
;;;cad@grapentin.org
;;;AutoCAD 2002
;;;AutoCAD 2006

;;;faltmarkierungen.zip entpacken und die Zeichnung faltmarkierung.dwg in einem Suchpfad ablegen
;;;gewnschte nderungen im Programm vornehmen (Layernamen, Layerfarben, Textstil, Position des Attributes fr die Blattgre, Firmenbezeichnung....)

;;;Liste fr Blattbreiten
;;;fr diese Blattbreiten sind die erforderlichen Blcke mit den Faltmarkierungen vorhanden
;;;manche nicht vorhandene Blattbreiten sind etwas unpraktisch, wegen der sonst sehr schmalen Tunnelfalten

;;;sinnlose Blattformate (hher als breit) einfach lschen - geht schneller als das Programm umzuschreiben
 
;;;die Faltmarkierung sind in der faltmarkierung.dwg so, dass am Plankopf die Breite 190 mm betrgt, danach
;;;kommen 1 bzw. 2 Tunnelfalten zum Ausgleich,
;;;dann bis zum Ende der Zeichnung 190 mm + Heftrand.
;;;(da es immer mal wieder Verwirrungen gibt - wir falten immer Dreieck auf Dreieck)
  
;;;es ist mglich, dass das Falten in der DIN anders geregelt ist 
;;;wer Falten nach DIN haben mchte, sollte die Faltmarkierungen in der Zeichnung faltmarkierungen.dwg entsprechend korrigieren

;;;wenn kein Lochverstrker gewnscht wird einfach vor die 3 Zeilen nach ;;;Lochverstrker Semikolons einfgen


;;;leere Zeichnung im gewnschten Pfad speichern
;;;lisp laden, mit Befehl "rahmen" starten
;;;unerwnschte Blcke lschen


                                        ;Textstil einstellen
(defun C:TEXTSTIL ()
  (setq TEXTSTIL "Norm8")
  (setq SCHRIFTDATEI "simplex8")
  (setq BREITENFAKTOR "0.8")
  (setq RUECKW "n")
  (setq KOPF "n")
  (setq VERTIKAL "n")
  (command "stil" TEXTSTIL SCHRIFTDATEI "0.0" "0.8" "0" RUECKW KOPF
           VERTIKAL) ;_ Ende von command
)                                     ;end of defun

(defun C:TEXTSTIL-COMP ()
  (setq TEXTSTIL "comp")
  (setq SCHRIFTDATEI "complex")
  (setq BREITENFAKTOR "1")
  (setq RUECKW "n")
  (setq KOPF "n")
  (setq VERTIKAL "n")
  (command "stil"       TEXTSTIL     SCHRIFTDATEI "0.0"
           BREITENFAKTOR             "0"          RUECKW
           KOPF         VERTIKAL
           ) ;_ Ende von command
)


                                       
(defun C:RAHMEN (/       ANZAHL-H        ANZAHL-L        BEZ
                 BEZDWG  BLOCK   F-1     F-2     F-3     F1-Block F2-Block F1-Block L1-Block L2-Block L3-Block
                 F-5     F-6     F-7     H1      H1-BEZ  L-1
                 L-2     L-3     L-6     L-7     L1      L1-BEZ
                 LISTE-H LISTE-L LISTE-L-NEU     P1      P1-F1
                 P1-F2   P1-R    P12     P13     P14     P15
                 P16     P17     P18     P19     P2      P20
                 P21     P3      P4      P4-R    P4-R2   P5
                 P6      P7      P8      PBE     PFAD    PFADBEZDWG
                 PRINT-A PRINT-Z PRINTL1 PZ1     PZ2     PZ3
                 PZ4     PZ5     TEXT    TH      VORH    X
                 Y       Z       ZA      ZEILE1  ZEILE2  ZEILE3
                 ZEILE4  ZEILE5  ZEILEN  ZX      ZY
                 )
  (C:TEXTSTIL)                          ;Programm Textstil ausfhren
  (command "lschen" "alle" "")
  (command "osmode" 0)
  (command "bereinig" "bl" "" "n")
  (command "bereinig" "bl" "" "n")
  (setq Z 0)
  

  

;;;fr weitere Blattbreiten Blcke mit Faltmarkierungen in faltmarkierung.dwg erstellen (Name = Blattbreite) und hier einfgen
;;;Semikolon vor unerwnschter Blattbreite einfgen!
  (setq LISTE-L (list
                  420
                  500
                  550
                  590
                  700
                  750
                  780
                  800
                  841
                  850
                  900
                  950
                  970
                  1050
                  1100
                  1120
                  1160
                  1189
                  1200
                  1250
                  1300
                  1350
                  1400
                  1450
                  1500
                  1550
                  1600
                  1650
                  1700
                  1730
                  1800
                  1850
                  1900
                  1950
                  2000
                  2050
                  2100
                  2150
                  2200
                  2250
                  2300
                  2350
                  2400
                  2450
                  2500
                  2550
                  2600
                  2650
                  2700
                  2750
                  2800
                  ) ;_ Ende von list
        )
  (setq LISTE-L-NEU LISTE-L)            
  (setq ANZAHL-L (length LISTE-L))      ;Anzahl Blattbreiten
                                        
;;;Liste fr Blatthhen
;;;neue Blatthhen knnen eingetragen werden
;;;Semikolon vor nicht wnschter Blatthhe einfgen
  (setq LISTE-H (list
                  297
                  350
                  400
                  420
                  440
                  450
                  500
                  550
                  594
                  650
                  700
                  750
                  800
                  841
                  850
                  891) ;_ Ende von list
  ) ;_ Ende von setq
  (setq ANZAHL-H (length LISTE-H))      ;Anzahl Blatthhen
        
  (setq P1 (list 0 0 0))
  (setq Pmax (list
               (+ (car P1) 2800)
               (+ (cadr P1) 900)
               0.0
               ) ;_ Ende von list
        ) ;_ Ende von setq
  (command "_insert" "faltmarkierungen" (list 0 0 0) 1 1 0) ; Block Faltmarkierung einfgen
  (setq HILFSOBJEKT (entlast))
  (command "_erase" HILFSOBJEKT "")
        
  (command "plinie" P1 Pmax "")
  (setq OBJEKT-HILFE (entlast))
  (command "zoom" "gr")
  (command "lschen" OBJEKT-HILFE "")
  (command "regenall")


;;;Bitte Voreinstellungen vornehmen!!!
         
;;;uerer Rahmen     
  (setq L-1 "___Rahmen_auszen") ;Layer
  (setq F-1 "5") ;Layerfarbe
  (command "layer" "mach" L-1 "fa" F-1 L-1 "")
        
;;;innerer Rahmen
  (setq L-2 "___Rahmen_innen")
  (setq F-2 "2")
  (command "layer" "mach" L-2 "fa" F-2 L-2 "")
         
;;;Text Blattgre
  (setq L-3 "___Rahmen_Blattgroesze")
  (setq F-3 "4")
  (command "layer" "mach" L-3 "fa" F-3 L-3 "")
        
;;;Text Firmenbezeichung im Heftbereich
  (setq L-6 "___Rahmen_txt")
  (setq F-6 "8")
  (command "layer" "mach" L-6 "fa" F-6 L-6 "")

;;;Lochverstrker
  (setq L-7 "___Rahmen_Lochverstaerker")
  (setq F-7 "8")
  (command "layer" "mach" L-7 "fa" F-7 L-7 "")
        
;;;Hilfe
  (setq L-8 "___Rahmen_-Hilfe-nicht-plotten")
  (setq F-8 "222")
  (command "layer" "mach" L-8 "fa" F-8 L-8 "p" "k" L-8 "")
         
         
;;;Blcke fr Faltmarkierung enthalten diese Layer - Layerfarbe anpassen
;;;Faltmarkierung dick
  (setq L1-Block "___Rahmen_Faltmarkierung_dick")
  (setq F1-Block "2")
  (command "layer" "mach" L1-Block "fa" F1-Block  L1-Block "")
  (setq L2-Block "___Rahmen_Faltmarkierung_duenn")
  (setq F2-Block "8")
  (command "layer" "mach" L2-Block "fa" F2-Block L2-Block "")
  (setq L3-Block "___Rahmen_Feld_Zeichnungsname")
  (setq F3-Block "250")
  (command "layer" "mach" L3-Block "fa" F3-Block L3-Block "")
  
         
;;;Faltmarkierung dnn
  (setq F-5 "8")
  (command "layer" "mach" "___RAHM-FALT-12" "fa" F-5 "___RAHM-FALT-12" "")
         
  
;;;bei immer gleichen Plankpfen die Position fr die Blattgre einstellen,
;;;bei wechselnden Plankpfen lsst sich die Position nach Einfgen des Blattrahmens
;;;verndern (Griff am Attribut)
;;;Position Attribut Blattgre einstellen!
         
;;;x-abstand f. Text Blattgre v. re/unteren Pkt d. ueren Rahmens
  (setq X 150.55) ;gewnschtes Ma eingeben (nicht negativ)
;;;y-abstand f. Text Blattgre v. re/unteren Pkt d. ueren Rahmens
  (setq Y 21.45) ;gewnschtes Ma eingeben
                                       
;;;vertikalen Text - im Heftbereich einfgen
;;;wenn dies nicht gewnscht wird - in nchster Zeile 1 durch 0 ersetzen
  (setq ZEILEN 1)
  (setq ZEILE1 ZEILE2
        ZEILE3 ZEILE4
        ZEILE5 NIL
        ) ;_ Ende von setq
  (setq ZEILE1 "Firma") ;eigene Texte einfgen
  (setq ZEILE2 "Adresse")
  (setq ZEILE3 "Tel.:")
  (setq ZEILE4 "Mail:")
         
;;;x-abstand f. Text Zeile1 v. li/unteren Pkt d. ueren Rahmens
  (setq ZX 10)
        
;;;y-abstand f. Text Blattgre v. li/unteren Pkt d. ueren Rahmens
  (setq ZY 5)
         
;;;Abstand der Zeilen voneinander bei Texthhe 2.5 -- 
  (setq ZA 2.5)
        
;;;Texthhe fr die Zeilen1-4
  (setq TH 1.5)

         
;;;Schleife fr Blatthhen
  (while (> ANZAHL-H 0)
    (setq PRINT-A (strcat "noch " (rtos ANZAHL-H 2 1) " Blatthhen"))
    (print PRINT-A)
    (setq H1 (car LISTE-H))
                            
;;;Schleife fr Blattbreiten
    (while (> ANZAHL-L 0)
      (setq L1 (car LISTE-L-NEU))
      (setq PRINTL1 (strcat (rtos L1 2 1) " x " (rtos H1 2 1)))
      (print PRINTL1)
      (setq P2 (list
                 (+ (car P1) L1)
                 (cadr P1)
                 0.0
                 ) ;_ Ende von list
            ) ;_ Ende von setq
      (setq P3 (list
                 (car P2)
                 (+ (cadr P1) H1)
                 0.0
                 ) ;_ Ende von list
            ) ;_ Ende von setq
      (setq P4 (list
                 (car P1)
                 (cadr P3)
                 0.0
                 ) ;_ Ende von list
            ) ;_ Ende von setq
                                        ;Layer setzen uerer Rahmen
      (command "layer" "se" L-1 "")
      (command "plinie" P1 P2 P3 P4 "s")
      (setq P1-R (list
                   (- (car P1) 20)
                   (+ (cadr P1) 10)
                   0.0
                   ) ;_ Ende von list
            ) ;_ Ende von setq
      (setq P4-R (list
                   (car P1-R)
                   (+ (cadr P1) 287)
                   0.0
                   ) ;_ Ende von list
            ) ;_ Ende von setq
      (setq P4-R2 (list
                    (car P1)
                    (+ (cadr P1) 297)
                    0.0
                    ) ;_ Ende von list
            ) ;_ Ende von setq
      (setq P1-F1 (list
                    (car P1)
                    (+ (cadr P1) (/ 297 2))
                    0.0
                    ) ;_ Ende von list
            ) ;_ Ende von setq
      (setq P1-F2 (list
                    (+ (car P1) 20)
                    (cadr P1-F1)
                    0.0
                    ) ;_ Ende von list
            ) ;_ Ende von setq


;;;Lochverstrker
      (command "layer" "se" L-7 "")
      (command "plinie" P4-R2 P4-R P1-R P1 "")
      (command "plinie" P1-F1 P1-F2 "")
      (setq P5 (list
                 (+ (car P1) 20)
                 (+ (cadr P1) 5)
                 0.0
                 ) ;_ Ende von list
            ) ;_ Ende von setq
                                        ;
      (setq PBE (list
                  (- (car P1) 25 -3)    ;3mm korrektur wegen blocktausch
                  (- (cadr P1) 5 -3)    ;3mm korrektur wegen blocktausch
                  0.0
                  ) ;_ Ende von list
            )                           ;Einfgepunkt der Blcke
                                        ;linker unterer Punkt


      (setq P6 (list
                 (- (car P2) 5)
                 (cadr P5)
                 0.0
                 ) ;_ Ende von list
            ) ;_ Ende von setq
      (setq P7 (list
                 (car P6)
                 (- (cadr P3) 5)
                 0.0
                 ) ;_ Ende von list
            ) ;_ Ende von setq
      (setq P8 (list
                 (car P5)
                 (cadr P7)
                 0.0
                 ) ;_ Ende von list
            ) ;_ Ende von setq
      
;;;Layer setzen innerer Rahmen
      (command "layer" "se" L-2 "")
      (command "plinie" P5 P6 P7 P8 "s")

;;;vertikale Linie Plankopf
      (setq P6-li (list
                    (- (car P2) 190)
                    (cadr P2)
                    0.0
                    )
            )
      (setq P7-li (list
                    (car P6-li)
                    (cadr P7)
                    0.0
                    )
            )
;;;(command "plinie" P6-li P7-li "")

;;;(command "layer" "se" L-8 "")	;Hilfslinie zur Anzeige-neuer Blattrahmen
;;;(command "plinie" P2 P6 "")
      
;;;Text im Heftbereich einfgen wenn Variable ZEILEN 1
      (if (= ZEILEN 1)
        (progn
          (setq PZ1 (list
                      (+ (car P1) ZX)
                      (+ (cadr P1) ZY)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq
          (setq PZ2 (list
                      (+ (car PZ1) ZA)
                      (cadr PZ1)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq
          (setq PZ3 (list
                      (+ (car PZ2) ZA)
                      (cadr PZ1)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq
          (setq PZ4 (list
                      (+ (car PZ3) ZA)
                      (cadr PZ1)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq
          (setq PZ5 (list
                      (+ (car PZ4) ZA)
                      (cadr PZ1)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq
          
;;;Layer setzen Text im Heftbereich
          (command "layer" "se" L-6 "")
          (C:TEXTSTIL-COMP)
          (command "text" PZ1 TH "90" ZEILE1)
          (command "text" PZ2 TH "90" ZEILE2)
          (command "text" PZ3 TH "90" ZEILE3)
          (command "text" PZ4 TH "90" ZEILE4)
          (command "text" PZ5 TH "90" ZEILE5)
          (C:TEXTSTIL)
          ) ;_ Ende von progn
        ()
        ) ;_ Ende von if
                                        
;;;horizontal bei 297 Faltstrich
      (if (> H1 297)
        (progn
          (setq P12 (list
                      (car P1)
                      (+ (cadr P1) 297)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq
          (setq P13 (list
                      (car P5)
                      (cadr P12)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq

          (command "layer" "se" L-1 "")
          (command "plinie" P12 P13 "")
          (setq P14 (list
                      (car P2)
                      (+ (cadr P2) 297)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq
          (setq P15 (list
                      (car P6)
                      (cadr P14)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq
          (command "plinie" P14 P15 "")
          ) ;_ Ende von progn
        ()
        ) ;_ Ende von if
                                        
;;;horizontal bei 594 Faltstrich
      (if (> H1 594)
        (progn
          (setq P16 (list
                      (car P12)
                      (+ (cadr P12) 297)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq
          (setq P17 (list
                      (car P13)
                      (cadr P16)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq
          (command "plinie" P16 P17 "")
          (setq P18 (list
                      (car P14)
                      (+ (cadr P14) 297)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq
          (setq P19 (list
                      (car P15)
                      (cadr P18)
                      0.0
                      ) ;_ Ende von list
                ) ;_ Ende von setq
          (command "plinie" P18 P19 "")
          ) ;_ Ende von progn
        ()
        ) ;_ Ende von if

      
;;;Block fr Faltmarkierung einfgen
      (setq BLOCK (rtos L1))
      (command "layer" "se" L-1 "")
      (command "_insert" BLOCK P2 1 1 0)
      (setq P20 (list
                  (car P3)
                  (- (cadr P3) 5)
                  0.0
                  ) ;_ Ende von list
            ) ;_ Ende von setq
      (command "_insert" BLOCK P20 1 1 0)

      (command "layer" "se" L-7 "")
      (command "_insert" "zeichnungsname" P1 1 1 0)

      
;;;Attribut "Blattgre" einfgen
      (C:TEXTSTIL)                      
      (setq L1-BEZ (rtos L1 2 1))
      (setq H1-BEZ (rtos H1 2 1))
      (command "layer" "se" L-3 "")
      (setq P21 (list
                  (- (car P2) X)
                  (+ (cadr P2) Y)
                  0.0
                  ) ;_ Ende von list
            ) ;_ Ende von setq
      (setq TEXT (strcat L1-BEZ "x" H1-BEZ))
      (setq BEZ (strcat L1-BEZ "-" H1-BEZ))
      (command "aflags" "0") ;sonst Attributssperrung im Block
      (command "attdef" "" "groesse" "format" TEXT P21 "2.5" "0")
   
;;;wblock erstellen
      (setq BEZDWG (strcat BEZ ".dwg"))
      (setq PFAD (getvar "dwgprefix"))
      (setq PFADBEZDWG (strcat PFAD BEZDWG))
      (setq VORH (findfile PFADBEZDWG))
      (if (= VORH NIL)
        (command "_.wblock" BEZ "" PBE "_all" "")
        ) ;_ Ende von if
      (if (/= VORH NIL)
        (command "_.wblock" BEZ "_y" "" PBE "_all" "")
        ) ;_ Ende von if
      
      (command "hoppla")
      (command "lschen" "_all" "")
      (setq Z (+ 1 Z))
                                       
      (setq LISTE-L-NEU (cdr LISTE-L-NEU)) ; ersten Wert lschen erledigt
      (setq ANZAHL-L (length LISTE-L-NEU)) ; listenlnge fr zhler
      ) ;ende Schleife Blattbreiten
     
    (setq LISTE-L-NEU LISTE-L) ; wieder alle Werte fr blattbreiten
    (setq ANZAHL-L (length LISTE-L)) ; wieder zhler fr alle blattbreiten
    (setq LISTE-H (cdr LISTE-H)) ; ersten wert lschen - erledigt
    (setq ANZAHL-H (length LISTE-H)) ; listenlnge fr zhler
    ) ;ende Schleife Blatthhen
  (setq PRINT-Z (strcat "es wurden " (rtos Z 2 1) " Blcke erstellt"))
  (print PRINT-Z)
  (princ)
  ) ;end of defun
(princ "\nType <rahmen> to start")

